/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToCoreLib.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToCoreLib.Api.Model
{
    /// <summary>
    ///  
    /// </summary>
    public class TokenResponse
    {
        /// <summary>
        /// Oauth access token
        /// </summary>
        public string access_token { get; set; }

        /// <summary>
        /// Expiration time in seconds (typically 356 days)
        /// </summary>
        public string expires_in { get; set; }

        /// <summary>
        /// The token to use to obtain a new access token, for example, if the current access token has expired. The refresh token is valid for 13 months.
        /// </summary>
        public string refresh_token { get; set; }

        /// <summary>
        /// GoTo product user organizer key
        /// </summary>
        public string organizer_key { get; set; }

        /// <summary>
        /// GoTo product account key (may be blank)
        /// </summary>
        public string account_key { get; set; }

        /// <summary>
        /// GoTo product type, i.e. personal or corporate (may be missing or blank)
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public Account_typeEnum? account_type { get; set; }

        /// <summary>
        /// GoTo product user organizer first name
        /// </summary>
        public string firstName { get; set; }

        /// <summary>
        /// GoTo product user organizer last name
        /// </summary>
        public string lastName { get; set; }

        /// <summary>
        /// GoTo product user organizer email
        /// </summary>
        public string email { get; set; }

        /// <summary>
        /// The version of the access token
        /// </summary>
        public string version { get; set; }

        /// <summary>
        /// The type of token
        /// </summary>
        public string token_type { get; set; }

        /// <summary>
        /// GoTo product type, i.e. personal or corporate (may be missing or blank)
        /// </summary>
        public enum Account_typeEnum
        {
            /// <summary>
            ///
            /// </summary>
            personal,
            /// <summary>
            ///
            /// </summary>
            corporate,
        };


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TokenResponse {\n");
            var access_tokenString = access_token.Stringify();
            if (!string.IsNullOrEmpty(access_tokenString))
                sb.AppendFormat("  access_token: {0}\n", access_tokenString);
            var expires_inString = expires_in.Stringify();
            if (!string.IsNullOrEmpty(expires_inString))
                sb.AppendFormat("  expires_in: {0}\n", expires_inString);
            var refresh_tokenString = refresh_token.Stringify();
            if (!string.IsNullOrEmpty(refresh_tokenString))
                sb.AppendFormat("  refresh_token: {0}\n", refresh_tokenString);
            var organizer_keyString = organizer_key.Stringify();
            if (!string.IsNullOrEmpty(organizer_keyString))
                sb.AppendFormat("  organizer_key: {0}\n", organizer_keyString);
            var account_keyString = account_key.Stringify();
            if (!string.IsNullOrEmpty(account_keyString))
                sb.AppendFormat("  account_key: {0}\n", account_keyString);
            var account_typeString = account_type.Stringify();
            if (!string.IsNullOrEmpty(account_typeString))
                sb.AppendFormat("  account_type: {0}\n", account_typeString);
            var firstNameString = firstName.Stringify();
            if (!string.IsNullOrEmpty(firstNameString))
                sb.AppendFormat("  firstName: {0}\n", firstNameString);
            var lastNameString = lastName.Stringify();
            if (!string.IsNullOrEmpty(lastNameString))
                sb.AppendFormat("  lastName: {0}\n", lastNameString);
            var emailString = email.Stringify();
            if (!string.IsNullOrEmpty(emailString))
                sb.AppendFormat("  email: {0}\n", emailString);
            var versionString = version.Stringify();
            if (!string.IsNullOrEmpty(versionString))
                sb.AppendFormat("  version: {0}\n", versionString);
            var token_typeString = token_type.Stringify();
            if (!string.IsNullOrEmpty(token_typeString))
                sb.AppendFormat("  token_type: {0}\n", token_typeString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
